package facades;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.jobs.Job;
import org.eclipse.rwt.lifecycle.UICallBack;
import org.eclipse.swt.widgets.Display;

public class JobFactoryImpl extends JobFactory {

	Job createJobInternal(final Display display, final String name, final JobRunnable runnable) {
		Job job = new Job(name) {
			protected IStatus run(final IProgressMonitor monitor) {
				final IStatus[] result = new IStatus[1];
				UICallBack.runNonUIThreadWithFakeContext(display,new Runnable() {
					public void run() {
						result[0] = runnable.run(monitor);
					}
				});
				return result[0];
			}
		};
		return job;
	}
}
