package facades;

import org.eclipse.core.runtime.jobs.Job;
import org.eclipse.swt.widgets.Display;

public abstract class JobFactory {
	private final static JobFactory IMPL;
	static {
		IMPL = (JobFactory) ImplementationLoader.newInstance(JobFactory.class);
	}

	public static Job createJob( final Display display, final String name, final JobRunnable runnable) {
		return IMPL.createJobInternal(display, name, runnable);
	}

	abstract Job createJobInternal( Display display, String name, JobRunnable runnable);
}
